
#include <SPI.h>
#include <MFRC522.h>
#define RST_PIN 9
#define SS_PIN 10

char znak = 0;  
MFRC522 mfrc522(SS_PIN, RST_PIN);
MFRC522::MIFARE_Key key;
MFRC522::StatusCode status;

byte sector_na_tagu; //proměná pro označení místa sektoru
byte adresa_bloku; //proměná pro označení adresy v bloku
byte dataBlock[] = {}; // pole do kterého budou hodnoty uklády
byte buffer;



void setup() 

    {
        
        Serial.begin(9600); 
        while(!Serial);
        mfrc522.PCD_Init();
        SPI.begin();
        Serial.println("Prilozte tag"); // vyzvání uživatele k přiložení tagu 
        Serial.println();
     
    }


void zobraz_obsah()
  {

      Serial.println(mfrc522.GetStatusCodeName(status));
      
  }

void vloz_data_na_tag()

  {
     sector_na_tagu = 1;
     adresa_bloku = 1;

                    Serial.print("Vkladani dat do tagu. Pokud nektere udaje zustavaji beze zmeny, pak je nutne je zadat stejne hodoty, ktere byly zobrazeny.");
                    Serial.print("Prvni hodnota:");
                    dataBlock[0] = Serial.read();
                    Serial.print("Doslo k ulozeni prvni hodnoty");
                    Serial.print("Druha hodnota:");
                    dataBlock[1] = Serial.read();
                    Serial.print("Doslo k ulozeni druhe hodnoty");
                    Serial.print("Treti hodnota:");
                    dataBlock[2] = Serial.read();
                    Serial.print("Doslo k ulozeni treti hodnoty");

                    byte trailerBlock = 1;
                    MFRC522::StatusCode status;
                    byte buffer[4];
                    byte size = sizeof(buffer);

                    Serial.println(F(" ..."));
                    
                    status = (MFRC522::StatusCode) mfrc522.MIFARE_Write(adresa_bloku, dataBlock, 16);
                    if (status != MFRC522::STATUS_OK) 
                    
                    {
                        Serial.print(F("MIFARE_Write() failed: "));
                        Serial.println(mfrc522.GetStatusCodeName(status));
                    } 
  }

  
void loop() 

  {

    
    if(!mfrc522.PICC_IsNewCardPresent())//ochrana, overeni zda je karta prilozena
                      
       return;
                      
    if(!mfrc522.PICC_ReadCardSerial())//ochrana, zda je mozne kartu cist
                      
       return;


    MFRC522::PICC_Type piccType=mfrc522.PICC_GetType(mfrc522.uid.sak);//ziskani typu karty

    if(piccType != MFRC522::PICC_TYPE_MIFARE_MINI //ověřeni zda karta je podporovaneho typu
        && piccType != MFRC522::PICC_TYPE_MIFARE_1K
        && piccType != MFRC522::PICC_TYPE_MIFARE_4K)
        {
          
            Serial.println(F("Tento program pracuje pouze s MIFARE kartami"));
            
            return;
                  
        }

      if(status != MFRC522::STATUS_OK)//ochrana
        {
          Serial.print(F("Selhalo to"));
          Serial.println(mfrc522.GetStatusCodeName(status));
          return;  
        }

      //získá informace, ktere jsou nasledne vyuzity v zobraz_obsah()
      
      byte trailerBlock = 1;
      MFRC522::StatusCode status;
      status = (MFRC522::StatusCode) mfrc522.PCD_Authenticate(MFRC522::PICC_CMD_MF_AUTH_KEY_A, trailerBlock, &key, &(mfrc522.uid));
      
        if (Serial.available() > 0) //pokud je linka pro seriovou komunikaci volna, pak spust komunikaci
        
        {
                
             znak = Serial.read();

             do 
             {

                 if (znak == 'a')//je spusten podprogram pro zobrazeni nactenych dat

                  {
                    zobraz_obsah();
                  }

                 if (znak == 'v')//je spusten podprogram pro vlozeni dat

                  {
                    vloz_data_na_tag();
                  }

                  if (znak == 'u')//je spusten podprogram pro zobrazeni nactenych dat

                  {
                    
                    Serial.print("Prvni ulozena hodnota je?");
                    Serial.print(dataBlock[0]);
                    Serial.print("Druha ulozena hodnota je?");
                    Serial.print(dataBlock[1]);
                    Serial.print("Treti ulozena hodnota je?");
                    Serial.print(dataBlock[2]);
                    
                  }
             }

             while (znak == 'k');

             Serial.println("dojde k ukonceni programu");
             
        }
}
